    SUBROUTINE die(routine, msg, file, line, unit)

! This routine prints an error message and stops.
! Inspired by Siesta 3.1 

!----------------------------------------------------------------------
!  Copyright 2003-2014 Ecole Normale Supérieure de Lyon, 
!  Centre National de la Recherche Scientifique,
!  Université Claude Bernard Lyon 1. All rights reserved.
!
!  This work is registered with the Agency for the Protection of Programs 
!  as IDDN.FR.001.100009.000.S.P.2014.000.30625
!
!  Authors: P. Fleurat-Lessard, P. Dayal
!  Contact: optnpath@gmail.com
!
! This file is part of "Opt'n Path".
!
!  "Opt'n Path" is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Affero General Public License as
!  published by the Free Software Foundation, either version 3 of the License,
!  or (at your option) any later version.
!
!  "Opt'n Path" is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Affero General Public License for more details.
!
!  You should have received a copy of the GNU Affero General Public License
!  along with "Opt'n Path". If not, see <http://www.gnu.org/licenses/>.
!
! Contact The Office of Technology Licensing, valorisation@ens-lyon.fr,
! for commercial licensing opportunities.
!----------------------------------------------------------------------

      Use VarTypes
      Use io_module

      implicit none
! Input Variables
      character(len=*), intent(in)           :: routine, msg
      character(len=*), intent(in), optional :: file
      integer(KINT), intent(in), optional      :: line, unit

! Local Variables
      integer(KINT)                            :: die_unit


      if (PRESENT(unit)) then
        die_unit = unit
      else
        die_unit = IOERR
      endif

      write(die_unit,'(a)') '*************************************************************'
      write(die_unit,'(a)') 'ERROR'
      write(die_unit,'(a)') ' '
      write(die_unit,'(3a)') TRIM(routine), ': ', TRIM(msg)
      write(die_unit,'(a)') ' '
      if (PRESENT(file)) write(die_unit,'(5x,2a)') 'File: ', file
      if (PRESENT(line)) write(die_unit,'(5x,a,i5)') 'Line: ', line
      write(die_unit,'(a)') '*************************************************************'

      if (die_unit .ne. IOERR) then
        write(die_unit,'(a)') 'Stopping Program'
      endif

      STOP 'Stopping Program'

    END SUBROUTINE die

